;;;; bearlibterminal-internal.lisp

(in-package #:bearlibterminal-internal)

(defun foreign-collect (wrapped-ptr &optional (free-fun #'cffi:foreign-free))
  (let ((ptr (autowrap:ptr wrapped-ptr)))
    (tg:finalize wrapped-ptr (lambda () (funcall free-fun ptr)))
    wrapped-ptr))

(defun terminal-print (x y string)
  (terminal-print8 x y string))

(defun terminal-set (string)
  (terminal-set8 string))

(defun terminal-measure (string)
  (terminal-measure8 string))

(defun terminal-read-str (x y max)
  (let ((input (foreign-collect (cffi:foreign-alloc :char :initial-element 0 :count max))))
    (terminal-read-str8 x y input max)
    (cffi:foreign-string-to-lisp input)))

(defun terminal-get (key default)
  (terminal-get8 key default))

(defun color-from-name (name)
  (color-from-name8 name))
